package org.ugasp.impl.games.demonstrator.protocol.rmai.objects;


import java.util.Map;
import java.util.HashMap;

import org.ugasp.protocol.rmai.RMAISerializable;


public class MyRMAIObject implements RMAISerializable {

	private String 	name;
	private String	club;
	private Short	age;
	private Byte	position;
	
	public MyRMAIObject(){}
	
	public MyRMAIObject(String name, String club, short age, byte position){
		this.name 		= name;
		this.club 		= club;
		this.age 		= Short.valueOf(age);
		this.position 	= Byte.valueOf(position);
	}
	
	public Map<String, Object> getSerializable(){
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("club",club);
		map.put("name",name);
		map.put("age",age);
		map.put("position",position);
		return map;
	}
	
	public void initialize(Map<String,Object> map){
		this.name 		= (String)map.get("name");
		this.club 		= (String)map.get("club");
		this.age 		= (Short)map.get("age");
		this.position 	= (Byte)map.get("position");
	}
	
	public String toString(){
		return "FirstRMAIObject: name = "+name+" --- club = "+club+" --- age = "+age+" --- position = "+position;
	}
	
	public boolean equals(Object o){
		if(!(o instanceof MyRMAIObject))
			return false;
		MyRMAIObject object = (MyRMAIObject)o;
		return (object.name.equals(name) && object.club.equals(club) && object.position == position && object.age == age);
	}

	public int hashCode(){
		// Values 17 and 37 are from recommendation 8
		// in the book "Effective Java - programming language guide" by Joshua Block.
		int result = 17;
		result = 37 * result + name.hashCode();
		result = 37 * result + club.hashCode();
		result = 37 * result + age;
		result = 37 * result + position;
		return result;
	}
	
}
